
#ifndef __FREESMARTPHONE_H__
#define __FREESMARTPHONE_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS


#define FREE_SMARTPHONE_TYPE_PHONE (free_smartphone_phone_get_type ())
#define FREE_SMARTPHONE_PHONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_PHONE, FreeSmartphonePhone))
#define FREE_SMARTPHONE_IS_PHONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_PHONE))
#define FREE_SMARTPHONE_PHONE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_PHONE, FreeSmartphonePhoneIface))

typedef struct _FreeSmartphonePhone FreeSmartphonePhone;
typedef struct _FreeSmartphonePhoneIface FreeSmartphonePhoneIface;

#define FREE_SMARTPHONE_TYPE_USAGE_SYSTEM_ACTION (free_smartphone_usage_system_action_get_type ())

#define FREE_SMARTPHONE_TYPE_RESOURCE (free_smartphone_resource_get_type ())
#define FREE_SMARTPHONE_RESOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_RESOURCE, FreeSmartphoneResource))
#define FREE_SMARTPHONE_IS_RESOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_RESOURCE))
#define FREE_SMARTPHONE_RESOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_RESOURCE, FreeSmartphoneResourceIface))

typedef struct _FreeSmartphoneResource FreeSmartphoneResource;
typedef struct _FreeSmartphoneResourceIface FreeSmartphoneResourceIface;

#define FREE_SMARTPHONE_TYPE_USAGE_RESOURCE_POLICY (free_smartphone_usage_resource_policy_get_type ())

#define FREE_SMARTPHONE_TYPE_PHONE_CALL (free_smartphone_phone_call_get_type ())
#define FREE_SMARTPHONE_PHONE_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_PHONE_CALL, FreeSmartphonePhoneCall))
#define FREE_SMARTPHONE_IS_PHONE_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_PHONE_CALL))
#define FREE_SMARTPHONE_PHONE_CALL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_PHONE_CALL, FreeSmartphonePhoneCallIface))

typedef struct _FreeSmartphonePhoneCall FreeSmartphonePhoneCall;
typedef struct _FreeSmartphonePhoneCallIface FreeSmartphonePhoneCallIface;

#define FREE_SMARTPHONE_TYPE_PREFERENCES (free_smartphone_preferences_get_type ())
#define FREE_SMARTPHONE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES, FreeSmartphonePreferences))
#define FREE_SMARTPHONE_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES))
#define FREE_SMARTPHONE_PREFERENCES_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES, FreeSmartphonePreferencesIface))

typedef struct _FreeSmartphonePreferences FreeSmartphonePreferences;
typedef struct _FreeSmartphonePreferencesIface FreeSmartphonePreferencesIface;

#define FREE_SMARTPHONE_TYPE_NETWORK (free_smartphone_network_get_type ())
#define FREE_SMARTPHONE_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_NETWORK, FreeSmartphoneNetwork))
#define FREE_SMARTPHONE_IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_NETWORK))
#define FREE_SMARTPHONE_NETWORK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_NETWORK, FreeSmartphoneNetworkIface))

typedef struct _FreeSmartphoneNetwork FreeSmartphoneNetwork;
typedef struct _FreeSmartphoneNetworkIface FreeSmartphoneNetworkIface;

#define FREE_SMARTPHONE_TYPE_USAGE (free_smartphone_usage_get_type ())
#define FREE_SMARTPHONE_USAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_USAGE, FreeSmartphoneUsage))
#define FREE_SMARTPHONE_IS_USAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_USAGE))
#define FREE_SMARTPHONE_USAGE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_USAGE, FreeSmartphoneUsageIface))

typedef struct _FreeSmartphoneUsage FreeSmartphoneUsage;
typedef struct _FreeSmartphoneUsageIface FreeSmartphoneUsageIface;

#define FREE_SMARTPHONE_TYPE_PREFERENCES_SERVICE (free_smartphone_preferences_service_get_type ())
#define FREE_SMARTPHONE_PREFERENCES_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES_SERVICE, FreeSmartphonePreferencesService))
#define FREE_SMARTPHONE_IS_PREFERENCES_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES_SERVICE))
#define FREE_SMARTPHONE_PREFERENCES_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_PREFERENCES_SERVICE, FreeSmartphonePreferencesServiceIface))

typedef struct _FreeSmartphonePreferencesService FreeSmartphonePreferencesService;
typedef struct _FreeSmartphonePreferencesServiceIface FreeSmartphonePreferencesServiceIface;

#define FREE_SMARTPHONE_TYPE_EVENTS (free_smartphone_events_get_type ())
#define FREE_SMARTPHONE_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TYPE_EVENTS, FreeSmartphoneEvents))
#define FREE_SMARTPHONE_IS_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TYPE_EVENTS))
#define FREE_SMARTPHONE_EVENTS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TYPE_EVENTS, FreeSmartphoneEventsIface))

typedef struct _FreeSmartphoneEvents FreeSmartphoneEvents;
typedef struct _FreeSmartphoneEventsIface FreeSmartphoneEventsIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_IDLE_STATE (free_smartphone_device_idle_state_get_type ())

#define FREE_SMARTPHONE_DEVICE_TYPE_POWER_STATUS (free_smartphone_device_power_status_get_type ())

#define FREE_SMARTPHONE_DEVICE_TYPE_INPUT (free_smartphone_device_input_get_type ())
#define FREE_SMARTPHONE_DEVICE_INPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INPUT, FreeSmartphoneDeviceInput))
#define FREE_SMARTPHONE_DEVICE_IS_INPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INPUT))
#define FREE_SMARTPHONE_DEVICE_INPUT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INPUT, FreeSmartphoneDeviceInputIface))

typedef struct _FreeSmartphoneDeviceInput FreeSmartphoneDeviceInput;
typedef struct _FreeSmartphoneDeviceInputIface FreeSmartphoneDeviceInputIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_SOUND_STATE (free_smartphone_device_sound_state_get_type ())

#define FREE_SMARTPHONE_DEVICE_TYPE_LED (free_smartphone_device_led_get_type ())
#define FREE_SMARTPHONE_DEVICE_LED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_LED, FreeSmartphoneDeviceLED))
#define FREE_SMARTPHONE_DEVICE_IS_LED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_LED))
#define FREE_SMARTPHONE_DEVICE_LED_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_LED, FreeSmartphoneDeviceLEDIface))

typedef struct _FreeSmartphoneDeviceLED FreeSmartphoneDeviceLED;
typedef struct _FreeSmartphoneDeviceLEDIface FreeSmartphoneDeviceLEDIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_POWER_SUPPLY (free_smartphone_device_power_supply_get_type ())
#define FREE_SMARTPHONE_DEVICE_POWER_SUPPLY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_SUPPLY, FreeSmartphoneDevicePowerSupply))
#define FREE_SMARTPHONE_DEVICE_IS_POWER_SUPPLY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_SUPPLY))
#define FREE_SMARTPHONE_DEVICE_POWER_SUPPLY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_SUPPLY, FreeSmartphoneDevicePowerSupplyIface))

typedef struct _FreeSmartphoneDevicePowerSupply FreeSmartphoneDevicePowerSupply;
typedef struct _FreeSmartphoneDevicePowerSupplyIface FreeSmartphoneDevicePowerSupplyIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_INFO (free_smartphone_device_info_get_type ())
#define FREE_SMARTPHONE_DEVICE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INFO, FreeSmartphoneDeviceInfo))
#define FREE_SMARTPHONE_DEVICE_IS_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INFO))
#define FREE_SMARTPHONE_DEVICE_INFO_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_INFO, FreeSmartphoneDeviceInfoIface))

typedef struct _FreeSmartphoneDeviceInfo FreeSmartphoneDeviceInfo;
typedef struct _FreeSmartphoneDeviceInfoIface FreeSmartphoneDeviceInfoIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_POWER_CONTROL (free_smartphone_device_power_control_get_type ())
#define FREE_SMARTPHONE_DEVICE_POWER_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_CONTROL, FreeSmartphoneDevicePowerControl))
#define FREE_SMARTPHONE_DEVICE_IS_POWER_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_CONTROL))
#define FREE_SMARTPHONE_DEVICE_POWER_CONTROL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_POWER_CONTROL, FreeSmartphoneDevicePowerControlIface))

typedef struct _FreeSmartphoneDevicePowerControl FreeSmartphoneDevicePowerControl;
typedef struct _FreeSmartphoneDevicePowerControlIface FreeSmartphoneDevicePowerControlIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_INPUT_STATE (free_smartphone_device_input_state_get_type ())

#define FREE_SMARTPHONE_DEVICE_TYPE_DISPLAY (free_smartphone_device_display_get_type ())
#define FREE_SMARTPHONE_DEVICE_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_DISPLAY, FreeSmartphoneDeviceDisplay))
#define FREE_SMARTPHONE_DEVICE_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_DISPLAY))
#define FREE_SMARTPHONE_DEVICE_DISPLAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_DISPLAY, FreeSmartphoneDeviceDisplayIface))

typedef struct _FreeSmartphoneDeviceDisplay FreeSmartphoneDeviceDisplay;
typedef struct _FreeSmartphoneDeviceDisplayIface FreeSmartphoneDeviceDisplayIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_REALTIME_CLOCK (free_smartphone_device_realtime_clock_get_type ())
#define FREE_SMARTPHONE_DEVICE_REALTIME_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_REALTIME_CLOCK, FreeSmartphoneDeviceRealtimeClock))
#define FREE_SMARTPHONE_DEVICE_IS_REALTIME_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_REALTIME_CLOCK))
#define FREE_SMARTPHONE_DEVICE_REALTIME_CLOCK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_REALTIME_CLOCK, FreeSmartphoneDeviceRealtimeClockIface))

typedef struct _FreeSmartphoneDeviceRealtimeClock FreeSmartphoneDeviceRealtimeClock;
typedef struct _FreeSmartphoneDeviceRealtimeClockIface FreeSmartphoneDeviceRealtimeClockIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_AUDIO (free_smartphone_device_audio_get_type ())
#define FREE_SMARTPHONE_DEVICE_AUDIO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_AUDIO, FreeSmartphoneDeviceAudio))
#define FREE_SMARTPHONE_DEVICE_IS_AUDIO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_AUDIO))
#define FREE_SMARTPHONE_DEVICE_AUDIO_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_AUDIO, FreeSmartphoneDeviceAudioIface))

typedef struct _FreeSmartphoneDeviceAudio FreeSmartphoneDeviceAudio;
typedef struct _FreeSmartphoneDeviceAudioIface FreeSmartphoneDeviceAudioIface;

#define FREE_SMARTPHONE_DEVICE_TYPE_IDLE_NOTIFIER (free_smartphone_device_idle_notifier_get_type ())
#define FREE_SMARTPHONE_DEVICE_IDLE_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_DEVICE_TYPE_IDLE_NOTIFIER, FreeSmartphoneDeviceIdleNotifier))
#define FREE_SMARTPHONE_DEVICE_IS_IDLE_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_IDLE_NOTIFIER))
#define FREE_SMARTPHONE_DEVICE_IDLE_NOTIFIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_DEVICE_TYPE_IDLE_NOTIFIER, FreeSmartphoneDeviceIdleNotifierIface))

typedef struct _FreeSmartphoneDeviceIdleNotifier FreeSmartphoneDeviceIdleNotifier;
typedef struct _FreeSmartphoneDeviceIdleNotifierIface FreeSmartphoneDeviceIdleNotifierIface;

#define FREE_SMARTPHONE_GSM_TYPE_PDP (free_smartphone_gsm_pdp_get_type ())
#define FREE_SMARTPHONE_GSM_PDP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_PDP, FreeSmartphoneGSMPDP))
#define FREE_SMARTPHONE_GSM_IS_PDP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_PDP))
#define FREE_SMARTPHONE_GSM_PDP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_PDP, FreeSmartphoneGSMPDPIface))

typedef struct _FreeSmartphoneGSMPDP FreeSmartphoneGSMPDP;
typedef struct _FreeSmartphoneGSMPDPIface FreeSmartphoneGSMPDPIface;

#define FREE_SMARTPHONE_GSM_TYPE_HZ (free_smartphone_gsm_hz_get_type ())
#define FREE_SMARTPHONE_GSM_HZ(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_HZ, FreeSmartphoneGSMHZ))
#define FREE_SMARTPHONE_GSM_IS_HZ(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_HZ))
#define FREE_SMARTPHONE_GSM_HZ_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_HZ, FreeSmartphoneGSMHZIface))

typedef struct _FreeSmartphoneGSMHZ FreeSmartphoneGSMHZ;
typedef struct _FreeSmartphoneGSMHZIface FreeSmartphoneGSMHZIface;

#define FREE_SMARTPHONE_GSM_TYPE_CALL_STATUS (free_smartphone_gsm_call_status_get_type ())

#define FREE_SMARTPHONE_GSM_TYPE_SIM_AUTH_STATUS (free_smartphone_gsm_sim_auth_status_get_type ())

#define FREE_SMARTPHONE_GSM_TYPE_MONITOR (free_smartphone_gsm_monitor_get_type ())
#define FREE_SMARTPHONE_GSM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_MONITOR, FreeSmartphoneGSMMonitor))
#define FREE_SMARTPHONE_GSM_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_MONITOR))
#define FREE_SMARTPHONE_GSM_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_MONITOR, FreeSmartphoneGSMMonitorIface))

typedef struct _FreeSmartphoneGSMMonitor FreeSmartphoneGSMMonitor;
typedef struct _FreeSmartphoneGSMMonitorIface FreeSmartphoneGSMMonitorIface;

#define FREE_SMARTPHONE_GSM_TYPE_MONITOR_NEIGHBOUR_CELL (free_smartphone_gsm_monitor_neighbour_cell_get_type ())
typedef struct _FreeSmartphoneGSMMonitorNeighbourCell FreeSmartphoneGSMMonitorNeighbourCell;

#define FREE_SMARTPHONE_GSM_TYPE_MUX (free_smartphone_gsm_mux_get_type ())
#define FREE_SMARTPHONE_GSM_MUX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_MUX, FreeSmartphoneGSMMUX))
#define FREE_SMARTPHONE_GSM_IS_MUX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_MUX))
#define FREE_SMARTPHONE_GSM_MUX_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_MUX, FreeSmartphoneGSMMUXIface))

typedef struct _FreeSmartphoneGSMMUX FreeSmartphoneGSMMUX;
typedef struct _FreeSmartphoneGSMMUXIface FreeSmartphoneGSMMUXIface;

#define FREE_SMARTPHONE_GSM_TYPE_DEVICE (free_smartphone_gsm_device_get_type ())
#define FREE_SMARTPHONE_GSM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_DEVICE, FreeSmartphoneGSMDevice))
#define FREE_SMARTPHONE_GSM_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_DEVICE))
#define FREE_SMARTPHONE_GSM_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_DEVICE, FreeSmartphoneGSMDeviceIface))

typedef struct _FreeSmartphoneGSMDevice FreeSmartphoneGSMDevice;
typedef struct _FreeSmartphoneGSMDeviceIface FreeSmartphoneGSMDeviceIface;

#define FREE_SMARTPHONE_GSM_TYPE_SMS (free_smartphone_gsm_sms_get_type ())
#define FREE_SMARTPHONE_GSM_SMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_SMS, FreeSmartphoneGSMSMS))
#define FREE_SMARTPHONE_GSM_IS_SMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_SMS))
#define FREE_SMARTPHONE_GSM_SMS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_SMS, FreeSmartphoneGSMSMSIface))

typedef struct _FreeSmartphoneGSMSMS FreeSmartphoneGSMSMS;
typedef struct _FreeSmartphoneGSMSMSIface FreeSmartphoneGSMSMSIface;

#define FREE_SMARTPHONE_GSM_TYPE_CALL (free_smartphone_gsm_call_get_type ())
#define FREE_SMARTPHONE_GSM_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_CALL, FreeSmartphoneGSMCall))
#define FREE_SMARTPHONE_GSM_IS_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_CALL))
#define FREE_SMARTPHONE_GSM_CALL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_CALL, FreeSmartphoneGSMCallIface))

typedef struct _FreeSmartphoneGSMCall FreeSmartphoneGSMCall;
typedef struct _FreeSmartphoneGSMCallIface FreeSmartphoneGSMCallIface;

#define FREE_SMARTPHONE_GSM_TYPE_CALL_DETAIL (free_smartphone_gsm_call_detail_get_type ())
typedef struct _FreeSmartphoneGSMCallDetail FreeSmartphoneGSMCallDetail;

#define FREE_SMARTPHONE_GSM_TYPE_NETWORK (free_smartphone_gsm_network_get_type ())
#define FREE_SMARTPHONE_GSM_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_NETWORK, FreeSmartphoneGSMNetwork))
#define FREE_SMARTPHONE_GSM_IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_NETWORK))
#define FREE_SMARTPHONE_GSM_NETWORK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_NETWORK, FreeSmartphoneGSMNetworkIface))

typedef struct _FreeSmartphoneGSMNetwork FreeSmartphoneGSMNetwork;
typedef struct _FreeSmartphoneGSMNetworkIface FreeSmartphoneGSMNetworkIface;

#define FREE_SMARTPHONE_GSM_TYPE_NETWORK_PROVIDER (free_smartphone_gsm_network_provider_get_type ())
typedef struct _FreeSmartphoneGSMNetworkProvider FreeSmartphoneGSMNetworkProvider;

#define FREE_SMARTPHONE_GSM_TYPE_CB (free_smartphone_gsm_cb_get_type ())
#define FREE_SMARTPHONE_GSM_CB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_CB, FreeSmartphoneGSMCB))
#define FREE_SMARTPHONE_GSM_IS_CB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_CB))
#define FREE_SMARTPHONE_GSM_CB_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_CB, FreeSmartphoneGSMCBIface))

typedef struct _FreeSmartphoneGSMCB FreeSmartphoneGSMCB;
typedef struct _FreeSmartphoneGSMCBIface FreeSmartphoneGSMCBIface;

#define FREE_SMARTPHONE_GSM_TYPE_SIM (free_smartphone_gsm_sim_get_type ())
#define FREE_SMARTPHONE_GSM_SIM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_GSM_TYPE_SIM, FreeSmartphoneGSMSIM))
#define FREE_SMARTPHONE_GSM_IS_SIM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_GSM_TYPE_SIM))
#define FREE_SMARTPHONE_GSM_SIM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_GSM_TYPE_SIM, FreeSmartphoneGSMSIMIface))

typedef struct _FreeSmartphoneGSMSIM FreeSmartphoneGSMSIM;
typedef struct _FreeSmartphoneGSMSIMIface FreeSmartphoneGSMSIMIface;

#define FREE_SMARTPHONE_GSM_TYPE_SIM_HOMEZONE (free_smartphone_gsm_sim_homezone_get_type ())
typedef struct _FreeSmartphoneGSMSIMHomezone FreeSmartphoneGSMSIMHomezone;

#define FREE_SMARTPHONE_GSM_TYPE_SIM_ENTRY (free_smartphone_gsm_sim_entry_get_type ())
typedef struct _FreeSmartphoneGSMSIMEntry FreeSmartphoneGSMSIMEntry;

#define FREE_SMARTPHONE_GSM_TYPE_SIM_MESSAGE (free_smartphone_gsm_sim_message_get_type ())
typedef struct _FreeSmartphoneGSMSIMMessage FreeSmartphoneGSMSIMMessage;

#define FREE_SMARTPHONE_TIME_TYPE_ALARM (free_smartphone_time_alarm_get_type ())
#define FREE_SMARTPHONE_TIME_ALARM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_TIME_TYPE_ALARM, FreeSmartphoneTimeAlarm))
#define FREE_SMARTPHONE_TIME_IS_ALARM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_TIME_TYPE_ALARM))
#define FREE_SMARTPHONE_TIME_ALARM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_TIME_TYPE_ALARM, FreeSmartphoneTimeAlarmIface))

typedef struct _FreeSmartphoneTimeAlarm FreeSmartphoneTimeAlarm;
typedef struct _FreeSmartphoneTimeAlarmIface FreeSmartphoneTimeAlarmIface;

#define FREE_SMARTPHONE_PIM_TYPE_MESSAGE_QUERY (free_smartphone_pim_message_query_get_type ())
#define FREE_SMARTPHONE_PIM_MESSAGE_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_QUERY, FreeSmartphonePIMMessageQuery))
#define FREE_SMARTPHONE_PIM_IS_MESSAGE_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_QUERY))
#define FREE_SMARTPHONE_PIM_MESSAGE_QUERY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_QUERY, FreeSmartphonePIMMessageQueryIface))

typedef struct _FreeSmartphonePIMMessageQuery FreeSmartphonePIMMessageQuery;
typedef struct _FreeSmartphonePIMMessageQueryIface FreeSmartphonePIMMessageQueryIface;

#define FREE_SMARTPHONE_PIM_TYPE_MESSAGE_FOLDER (free_smartphone_pim_message_folder_get_type ())
#define FREE_SMARTPHONE_PIM_MESSAGE_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_FOLDER, FreeSmartphonePIMMessageFolder))
#define FREE_SMARTPHONE_PIM_IS_MESSAGE_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_FOLDER))
#define FREE_SMARTPHONE_PIM_MESSAGE_FOLDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE_FOLDER, FreeSmartphonePIMMessageFolderIface))

typedef struct _FreeSmartphonePIMMessageFolder FreeSmartphonePIMMessageFolder;
typedef struct _FreeSmartphonePIMMessageFolderIface FreeSmartphonePIMMessageFolderIface;

#define FREE_SMARTPHONE_PIM_TYPE_SOURCES (free_smartphone_pim_sources_get_type ())
#define FREE_SMARTPHONE_PIM_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCES, FreeSmartphonePIMSources))
#define FREE_SMARTPHONE_PIM_IS_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCES))
#define FREE_SMARTPHONE_PIM_SOURCES_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCES, FreeSmartphonePIMSourcesIface))

typedef struct _FreeSmartphonePIMSources FreeSmartphonePIMSources;
typedef struct _FreeSmartphonePIMSourcesIface FreeSmartphonePIMSourcesIface;

#define FREE_SMARTPHONE_PIM_TYPE_CONTACT (free_smartphone_pim_contact_get_type ())
#define FREE_SMARTPHONE_PIM_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT, FreeSmartphonePIMContact))
#define FREE_SMARTPHONE_PIM_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT))
#define FREE_SMARTPHONE_PIM_CONTACT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT, FreeSmartphonePIMContactIface))

typedef struct _FreeSmartphonePIMContact FreeSmartphonePIMContact;
typedef struct _FreeSmartphonePIMContactIface FreeSmartphonePIMContactIface;

#define FREE_SMARTPHONE_PIM_TYPE_CONTACTS (free_smartphone_pim_contacts_get_type ())
#define FREE_SMARTPHONE_PIM_CONTACTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACTS, FreeSmartphonePIMContacts))
#define FREE_SMARTPHONE_PIM_IS_CONTACTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACTS))
#define FREE_SMARTPHONE_PIM_CONTACTS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACTS, FreeSmartphonePIMContactsIface))

typedef struct _FreeSmartphonePIMContacts FreeSmartphonePIMContacts;
typedef struct _FreeSmartphonePIMContactsIface FreeSmartphonePIMContactsIface;

#define FREE_SMARTPHONE_PIM_TYPE_CONTACT_QUERY (free_smartphone_pim_contact_query_get_type ())
#define FREE_SMARTPHONE_PIM_CONTACT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT_QUERY, FreeSmartphonePIMContactQuery))
#define FREE_SMARTPHONE_PIM_IS_CONTACT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT_QUERY))
#define FREE_SMARTPHONE_PIM_CONTACT_QUERY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_CONTACT_QUERY, FreeSmartphonePIMContactQueryIface))

typedef struct _FreeSmartphonePIMContactQuery FreeSmartphonePIMContactQuery;
typedef struct _FreeSmartphonePIMContactQueryIface FreeSmartphonePIMContactQueryIface;

#define FREE_SMARTPHONE_PIM_TYPE_MESSAGES (free_smartphone_pim_messages_get_type ())
#define FREE_SMARTPHONE_PIM_MESSAGES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGES, FreeSmartphonePIMMessages))
#define FREE_SMARTPHONE_PIM_IS_MESSAGES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGES))
#define FREE_SMARTPHONE_PIM_MESSAGES_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGES, FreeSmartphonePIMMessagesIface))

typedef struct _FreeSmartphonePIMMessages FreeSmartphonePIMMessages;
typedef struct _FreeSmartphonePIMMessagesIface FreeSmartphonePIMMessagesIface;

#define FREE_SMARTPHONE_PIM_TYPE_SOURCE (free_smartphone_pim_source_get_type ())
#define FREE_SMARTPHONE_PIM_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCE, FreeSmartphonePIMSource))
#define FREE_SMARTPHONE_PIM_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCE))
#define FREE_SMARTPHONE_PIM_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_SOURCE, FreeSmartphonePIMSourceIface))

typedef struct _FreeSmartphonePIMSource FreeSmartphonePIMSource;
typedef struct _FreeSmartphonePIMSourceIface FreeSmartphonePIMSourceIface;

#define FREE_SMARTPHONE_PIM_TYPE_MESSAGE (free_smartphone_pim_message_get_type ())
#define FREE_SMARTPHONE_PIM_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE, FreeSmartphonePIMMessage))
#define FREE_SMARTPHONE_PIM_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE))
#define FREE_SMARTPHONE_PIM_MESSAGE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FREE_SMARTPHONE_PIM_TYPE_MESSAGE, FreeSmartphonePIMMessageIface))

typedef struct _FreeSmartphonePIMMessage FreeSmartphonePIMMessage;
typedef struct _FreeSmartphonePIMMessageIface FreeSmartphonePIMMessageIface;

typedef enum  {
	FREE_SMARTPHONE_ERROR_INVALID_PARAMETER,
	FREE_SMARTPHONE_ERROR_INTERNAL_ERROR,
	FREE_SMARTPHONE_ERROR_SYSTEM_ERROR,
	FREE_SMARTPHONE_ERROR_UNSUPPORTED
} FreeSmartphoneError;
#define FREE_SMARTPHONE_ERROR free_smartphone_error_quark ()
struct _FreeSmartphonePhoneIface {
	GTypeInterface parent_iface;
	char** (*init_protocols) (FreeSmartphonePhone* self, int* result_length1, GError** error);
	char* (*create_call) (FreeSmartphonePhone* self, const char* number, const char* protocol, gboolean force, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_USAGE_SYSTEM_ACTION_SUSPEND,
	FREE_SMARTPHONE_USAGE_SYSTEM_ACTION_RESUME,
	FREE_SMARTPHONE_USAGE_SYSTEM_ACTION_SHUTDOWN,
	FREE_SMARTPHONE_USAGE_SYSTEM_ACTION_REBOOT
} FreeSmartphoneUsageSystemAction;

typedef enum  {
	FREE_SMARTPHONE_RESOURCE_ERROR_NOT_ENABLED
} FreeSmartphoneResourceError;
#define FREE_SMARTPHONE_RESOURCE_ERROR free_smartphone_resource_error_quark ()
struct _FreeSmartphoneResourceIface {
	GTypeInterface parent_iface;
	void (*enable) (FreeSmartphoneResource* self, GError** error);
	void (*disable) (FreeSmartphoneResource* self, GError** error);
	void (*suspend) (FreeSmartphoneResource* self, GError** error);
	void (*resume) (FreeSmartphoneResource* self, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_USAGE_RESOURCE_POLICY_AUTO,
	FREE_SMARTPHONE_USAGE_RESOURCE_POLICY_DISABLED,
	FREE_SMARTPHONE_USAGE_RESOURCE_POLICY_ENABLED
} FreeSmartphoneUsageResourcePolicy;

struct _FreeSmartphonePhoneCallIface {
	GTypeInterface parent_iface;
	char* (*get_peer) (FreeSmartphonePhoneCall* self, GError** error);
	char* (*initiate) (FreeSmartphonePhoneCall* self, GError** error);
	char* (*activate) (FreeSmartphonePhoneCall* self, GError** error);
	char* (*release) (FreeSmartphonePhoneCall* self, GError** error);
	char* (*get_status) (FreeSmartphonePhoneCall* self, GError** error);
	void (*remove) (FreeSmartphonePhoneCall* self, GError** error);
};

struct _FreeSmartphonePreferencesIface {
	GTypeInterface parent_iface;
	char** (*get_services) (FreeSmartphonePreferences* self, int* result_length1, GError** error);
	char* (*get_service) (FreeSmartphonePreferences* self, const char* name, GError** error);
	char** (*get_profiles) (FreeSmartphonePreferences* self, int* result_length1, GError** error);
	char* (*get_profile) (FreeSmartphonePreferences* self, GError** error);
	void (*set_profile) (FreeSmartphonePreferences* self, const char* profile, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_USAGE_ERROR_POLICY_UNKNOWN,
	FREE_SMARTPHONE_USAGE_ERROR_POLICY_DISABLED,
	FREE_SMARTPHONE_USAGE_ERROR_RESOURCE_UNKNOWN,
	FREE_SMARTPHONE_USAGE_ERROR_RESOURCE_EXISTS,
	FREE_SMARTPHONE_USAGE_ERROR_RESOURCE_IN_USE,
	FREE_SMARTPHONE_USAGE_ERROR_USER_EXISTS,
	FREE_SMARTPHONE_USAGE_ERROR_USER_UNKNOWN
} FreeSmartphoneUsageError;
#define FREE_SMARTPHONE_USAGE_ERROR free_smartphone_usage_error_quark ()
struct _FreeSmartphoneNetworkIface {
	GTypeInterface parent_iface;
	void (*start_connection_sharing_with_interface) (FreeSmartphoneNetwork* self, const char* interface, GError** error);
};

struct _FreeSmartphoneUsageIface {
	GTypeInterface parent_iface;
	void (*register_resource) (FreeSmartphoneUsage* self, const char* name, const char* path, GError** error);
	void (*unregister_resource) (FreeSmartphoneUsage* self, const char* name, GError** error);
	char** (*list_resources) (FreeSmartphoneUsage* self, int* result_length1, GError** error);
	FreeSmartphoneUsageResourcePolicy (*get_resource_policy) (FreeSmartphoneUsage* self, const char* name, GError** error);
	void (*set_resource_policy) (FreeSmartphoneUsage* self, const char* name, FreeSmartphoneUsageResourcePolicy policy, GError** error);
	gboolean (*get_resource_state) (FreeSmartphoneUsage* self, const char* name, GError** error);
	char** (*get_resource_users) (FreeSmartphoneUsage* self, const char* name, int* result_length1, GError** error);
	void (*request_resource) (FreeSmartphoneUsage* self, const char* name, GError** error);
	void (*release_resource) (FreeSmartphoneUsage* self, const char* name, GError** error);
	void (*suspend) (FreeSmartphoneUsage* self, GError** error);
	void (*shutdown) (FreeSmartphoneUsage* self, GError** error);
	void (*reboot) (FreeSmartphoneUsage* self, GError** error);
};

struct _FreeSmartphonePreferencesServiceIface {
	GTypeInterface parent_iface;
	char** (*get_keys) (FreeSmartphonePreferencesService* self, int* result_length1, GError** error);
	GValue (*get_value) (FreeSmartphonePreferencesService* self, const char* key, GError** error);
	void (*set_value) (FreeSmartphonePreferencesService* self, const char* key, const GValue* value, GError** error);
	gboolean (*is_profilable) (FreeSmartphonePreferencesService* self, const char* key, GError** error);
	char* (*get_type_) (FreeSmartphonePreferencesService* self, const char* key, GError** error);
};

struct _FreeSmartphoneEventsIface {
	GTypeInterface parent_iface;
	void (*add_rule) (FreeSmartphoneEvents* self, const char* rule, GError** error);
	void (*remove_rule) (FreeSmartphoneEvents* self, const char* name, GError** error);
	void (*trigger_test) (FreeSmartphoneEvents* self, const char* name, gboolean value, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_UNKNOWN_FORMAT,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_PLAYER_ERROR,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_NOT_PLAYING,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_ALREADY_PLAYING,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_SCENARIO_INVALID,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_SCENARIO_STACK_UNDERFLOW,
	FREE_SMARTPHONE_DEVICE_AUDIO_ERROR_DEVICE_FAILED
} FreeSmartphoneDeviceAudioError;
#define FREE_SMARTPHONE_DEVICE_AUDIO_ERROR free_smartphone_device_audio_error_quark ()
typedef enum  {
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_BUSY,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_IDLE,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_IDLE_DIM,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_IDLE_PRELOCK,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_LOCK,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_SUSPEND,
	FREE_SMARTPHONE_DEVICE_IDLE_STATE_AWAKE
} FreeSmartphoneDeviceIdleState;

typedef enum  {
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_CHARGING,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_DISCHARGING,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_FULL,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_EMPTY,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_CRITICAL,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_REMOVED,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_UNKNOWN,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_ONLINE,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_OFFLINE,
	FREE_SMARTPHONE_DEVICE_POWER_STATUS_AC
} FreeSmartphoneDevicePowerStatus;

struct _FreeSmartphoneDeviceInputIface {
	GTypeInterface parent_iface;
	char* (*get_id) (FreeSmartphoneDeviceInput* self, GError** error);
	char* (*get_capabilities) (FreeSmartphoneDeviceInput* self, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_DEVICE_SOUND_STATE_PLAYING,
	FREE_SMARTPHONE_DEVICE_SOUND_STATE_STOPPED
} FreeSmartphoneDeviceSoundState;

struct _FreeSmartphoneDeviceLEDIface {
	GTypeInterface parent_iface;
	void (*set_brightness) (FreeSmartphoneDeviceLED* self, gint brightness, GError** error);
	void (*set_blinking) (FreeSmartphoneDeviceLED* self, gint on_duration, gint off_duration, GError** error);
	void (*blink_seconds) (FreeSmartphoneDeviceLED* self, gint seconds, gint on_duration, gint off_duration, GError** error);
	void (*set_networking) (FreeSmartphoneDeviceLED* self, const char* interface, const char* mode, GError** error);
};

struct _FreeSmartphoneDevicePowerSupplyIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_info) (FreeSmartphoneDevicePowerSupply* self, GError** error);
	gint (*get_capacity) (FreeSmartphoneDevicePowerSupply* self, GError** error);
	FreeSmartphoneDevicePowerStatus (*get_power_status) (FreeSmartphoneDevicePowerSupply* self, GError** error);
};

struct _FreeSmartphoneDeviceInfoIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_cpu_info) (FreeSmartphoneDeviceInfo* self, GError** error);
};

struct _FreeSmartphoneDevicePowerControlIface {
	GTypeInterface parent_iface;
	gboolean (*get_power) (FreeSmartphoneDevicePowerControl* self, GError** error);
	void (*set_power) (FreeSmartphoneDevicePowerControl* self, gboolean on, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_DEVICE_INPUT_STATE_PRESSED,
	FREE_SMARTPHONE_DEVICE_INPUT_STATE_HELD,
	FREE_SMARTPHONE_DEVICE_INPUT_STATE_RELEASED
} FreeSmartphoneDeviceInputState;

struct _FreeSmartphoneDeviceDisplayIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_info) (FreeSmartphoneDeviceDisplay* self, GError** error);
	gint (*get_brightness) (FreeSmartphoneDeviceDisplay* self, GError** error);
	void (*set_brightness) (FreeSmartphoneDeviceDisplay* self, gint brightness, GError** error);
	gboolean (*get_backlight_power) (FreeSmartphoneDeviceDisplay* self, GError** error);
	void (*set_backlight_power) (FreeSmartphoneDeviceDisplay* self, gboolean power, GError** error);
};

struct _FreeSmartphoneDeviceRealtimeClockIface {
	GTypeInterface parent_iface;
	gint (*get_current_time) (FreeSmartphoneDeviceRealtimeClock* self, GError** error);
	void (*set_current_time) (FreeSmartphoneDeviceRealtimeClock* self, gint time, GError** error);
	gint (*get_wakeup_time) (FreeSmartphoneDeviceRealtimeClock* self, GError** error);
	void (*set_wakeup_time) (FreeSmartphoneDeviceRealtimeClock* self, gint time, GError** error);
};

struct _FreeSmartphoneDeviceAudioIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_info) (FreeSmartphoneDeviceAudio* self, GError** error);
	char** (*get_supported_formats) (FreeSmartphoneDeviceAudio* self, int* result_length1, GError** error);
	char** (*get_available_scenarios) (FreeSmartphoneDeviceAudio* self, int* result_length1, GError** error);
	void (*play_sound) (FreeSmartphoneDeviceAudio* self, const char* name, gint loop, gint length, GError** error);
	void (*stop_sound) (FreeSmartphoneDeviceAudio* self, const char* name, GError** error);
	void (*stop_all_sounds) (FreeSmartphoneDeviceAudio* self, GError** error);
	char* (*get_scenario) (FreeSmartphoneDeviceAudio* self, GError** error);
	void (*set_scenario) (FreeSmartphoneDeviceAudio* self, const char* scenario, GError** error);
	void (*push_scenario) (FreeSmartphoneDeviceAudio* self, const char* scenario, GError** error);
	char* (*pull_scenario) (FreeSmartphoneDeviceAudio* self, GError** error);
};

struct _FreeSmartphoneDeviceIdleNotifierIface {
	GTypeInterface parent_iface;
	FreeSmartphoneDeviceIdleState (*get_state) (FreeSmartphoneDeviceIdleNotifier* self, GError** error);
	GHashTable* (*get_timeouts) (FreeSmartphoneDeviceIdleNotifier* self, GError** error);
	void (*set_timeout) (FreeSmartphoneDeviceIdleNotifier* self, FreeSmartphoneDeviceIdleState status, gint timeout, GError** error);
	void (*set_state) (FreeSmartphoneDeviceIdleNotifier* self, FreeSmartphoneDeviceIdleState status, GError** error);
};

struct _FreeSmartphoneGSMPDPIface {
	GTypeInterface parent_iface;
	char** (*list_gprs_classes) (FreeSmartphoneGSMPDP* self, int* result_length1, GError** error);
	char* (*get_current_gprs_class) (FreeSmartphoneGSMPDP* self, GError** error);
	void (*set_current_gprs_class) (FreeSmartphoneGSMPDP* self, const char* device_class, GError** error);
	GHashTable* (*get_network_status) (FreeSmartphoneGSMPDP* self, GError** error);
	gint (*activate_context) (FreeSmartphoneGSMPDP* self, const char* apn, const char* username, const char* password, GError** error);
	void (*deactivate_context) (FreeSmartphoneGSMPDP* self, gint index, GError** error);
	char* (*get_context_status) (FreeSmartphoneGSMPDP* self, gint index, GError** error);
};

struct _FreeSmartphoneGSMHZIface {
	GTypeInterface parent_iface;
	char** (*get_known_home_zones) (FreeSmartphoneGSMHZ* self, int* result_length1, GError** error);
	char* (*get_home_zone_status) (FreeSmartphoneGSMHZ* self, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_GSM_CALL_STATUS_INCOMING,
	FREE_SMARTPHONE_GSM_CALL_STATUS_OUTGOING,
	FREE_SMARTPHONE_GSM_CALL_STATUS_ACTIVE,
	FREE_SMARTPHONE_GSM_CALL_STATUS_HELD,
	FREE_SMARTPHONE_GSM_CALL_STATUS_RELEASE
} FreeSmartphoneGSMCallStatus;

typedef enum  {
	FREE_SMARTPHONE_GSM_SIM_AUTH_STATUS_READY,
	FREE_SMARTPHONE_GSM_SIM_AUTH_STATUS_PIN_REQUIRED,
	FREE_SMARTPHONE_GSM_SIM_AUTH_STATUS_PUK_REQUIRED,
	FREE_SMARTPHONE_GSM_SIM_AUTH_STATUS_PIN2_REQUIRED,
	FREE_SMARTPHONE_GSM_SIM_AUTH_STATUS_PUK2_REQUIRED
} FreeSmartphoneGSMSIMAuthStatus;

struct _FreeSmartphoneGSMMonitorNeighbourCell {
	GHashTable* attr1;
};

struct _FreeSmartphoneGSMMonitorIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_serving_cell_information) (FreeSmartphoneGSMMonitor* self, GError** error);
	FreeSmartphoneGSMMonitorNeighbourCell* (*get_neighbour_cell_information) (FreeSmartphoneGSMMonitor* self, int* result_length1, GError** error);
};

typedef enum  {
	FREE_SMARTPHONE_GSM_CALL_ERROR_NOT_FOUND,
	FREE_SMARTPHONE_GSM_CALL_ERROR_NOT_AN_EMERGENCY_NUMBER
} FreeSmartphoneGSMCallError;
#define FREE_SMARTPHONE_GSM_CALL_ERROR free_smartphone_gsm_call_error_quark ()
struct _FreeSmartphoneGSMMUXIface {
	GTypeInterface parent_iface;
	void (*open_session) (FreeSmartphoneGSMMUX* self, gboolean advanced, gint framesize, const char* portname, gint portspeed, GError** error);
	void (*close_session) (FreeSmartphoneGSMMUX* self, GError** error);
	void (*alloc_channel) (FreeSmartphoneGSMMUX* self, const char* origin, gint channel, char** path, gint* allocated_channel, GError** error);
	void (*release_channel) (FreeSmartphoneGSMMUX* self, const char* origin, GError** error);
	void (*set_status) (FreeSmartphoneGSMMUX* self, gint channel, const char* status, GError** error);
};

struct _FreeSmartphoneGSMDeviceIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_info) (FreeSmartphoneGSMDevice* self, GError** error);
	gboolean (*get_antenna_power) (FreeSmartphoneGSMDevice* self, GError** error);
	void (*set_antenna_power) (FreeSmartphoneGSMDevice* self, gboolean antenna_power, GError** error);
	GHashTable* (*get_features) (FreeSmartphoneGSMDevice* self, GError** error);
	gint (*get_speaker_volume) (FreeSmartphoneGSMDevice* self, GError** error);
	void (*set_speaker_volume) (FreeSmartphoneGSMDevice* self, gint volume, GError** error);
	gboolean (*get_microphone_muted) (FreeSmartphoneGSMDevice* self, GError** error);
	void (*set_microphone_muted) (FreeSmartphoneGSMDevice* self, gboolean muted, GError** error);
	void (*get_power_status) (FreeSmartphoneGSMDevice* self, char** status, gint* level, GError** error);
	gboolean (*get_sim_buffers_sms) (FreeSmartphoneGSMDevice* self, GError** error);
	void (*set_sim_buffers_sms) (FreeSmartphoneGSMDevice* self, gboolean sim_buffers_sms, GError** error);
};

struct _FreeSmartphoneGSMSMSIface {
	GTypeInterface parent_iface;
	void (*send_message) (FreeSmartphoneGSMSMS* self, const char* recipient_number, const char* contents, GHashTable* properties, gint* transaction_index, char** timestamp, GError** error);
	void (*ack_message) (FreeSmartphoneGSMSMS* self, const char* contents, GHashTable* properties, GError** error);
	void (*nack_message) (FreeSmartphoneGSMSMS* self, const char* contents, GHashTable* properties, GError** error);
};

struct _FreeSmartphoneGSMCallDetail {
	gint id;
	FreeSmartphoneGSMCallStatus status;
	GHashTable* properties;
};

struct _FreeSmartphoneGSMCallIface {
	GTypeInterface parent_iface;
	void (*emergency) (FreeSmartphoneGSMCall* self, const char* number, GError** error);
	void (*activate) (FreeSmartphoneGSMCall* self, gint id, GError** error);
	void (*activate_conference) (FreeSmartphoneGSMCall* self, gint id, GError** error);
	void (*release) (FreeSmartphoneGSMCall* self, gint id, GError** error);
	void (*hold_active) (FreeSmartphoneGSMCall* self, GError** error);
	void (*join) (FreeSmartphoneGSMCall* self, GError** error);
	void (*transfer) (FreeSmartphoneGSMCall* self, const char* number, GError** error);
	void (*release_held) (FreeSmartphoneGSMCall* self, GError** error);
	void (*release_all) (FreeSmartphoneGSMCall* self, GError** error);
	gint (*initiate) (FreeSmartphoneGSMCall* self, const char* number, const char* type, GError** error);
	FreeSmartphoneGSMCallDetail* (*list_calls) (FreeSmartphoneGSMCall* self, int* result_length1, GError** error);
	void (*send_dtmf) (FreeSmartphoneGSMCall* self, const char* tones, GError** error);
};

struct _FreeSmartphoneGSMNetworkProvider {
	char* attr1;
	char* attr2;
	char* attr3;
	char* attr4;
	char* attr5;
};

struct _FreeSmartphoneGSMNetworkIface {
	GTypeInterface parent_iface;
	void (*register_) (FreeSmartphoneGSMNetwork* self, GError** error);
	void (*unregister) (FreeSmartphoneGSMNetwork* self, GError** error);
	GHashTable* (*get_status) (FreeSmartphoneGSMNetwork* self, GError** error);
	gint (*get_signal_strength) (FreeSmartphoneGSMNetwork* self, GError** error);
	FreeSmartphoneGSMNetworkProvider* (*list_providers) (FreeSmartphoneGSMNetwork* self, int* result_length1, GError** error);
	void (*register_with_provider) (FreeSmartphoneGSMNetwork* self, const char* operator_code, GError** error);
	void (*get_network_country_code) (FreeSmartphoneGSMNetwork* self, char** dial_code, char** country_name, GError** error);
	GHashTable* (*get_call_forwarding) (FreeSmartphoneGSMNetwork* self, const char* reason, GError** error);
	void (*enable_call_forwarding) (FreeSmartphoneGSMNetwork* self, const char* reason, const char* class_, const char* number, gint timeout, GError** error);
	void (*disable_call_forwarding) (FreeSmartphoneGSMNetwork* self, const char* reason, const char* class_, GError** error);
	void (*set_calling_identification) (FreeSmartphoneGSMNetwork* self, const char* visible, GError** error);
	char* (*get_calling_identification) (FreeSmartphoneGSMNetwork* self, GError** error);
	void (*send_ussd_request) (FreeSmartphoneGSMNetwork* self, const char* request, GError** error);
};

struct _FreeSmartphoneGSMCBIface {
	GTypeInterface parent_iface;
	char* (*get_cell_broadcast_subscriptions) (FreeSmartphoneGSMCB* self, GError** error);
	void (*set_cell_broadcast_subscriptions) (FreeSmartphoneGSMCB* self, const char* channels, GError** error);
};

struct _FreeSmartphoneGSMSIMHomezone {
	char* attr1;
	gint attr2;
	gint attr3;
	gint attr4;
};

struct _FreeSmartphoneGSMSIMEntry {
	gint attr1;
	char* attr2;
	char* attr3;
};

struct _FreeSmartphoneGSMSIMMessage {
	gint attr1;
	char* attr2;
	char* attr3;
	char* attr4;
	GHashTable* attr5;
};

struct _FreeSmartphoneGSMSIMIface {
	GTypeInterface parent_iface;
	FreeSmartphoneGSMSIMAuthStatus (*get_auth_status) (FreeSmartphoneGSMSIM* self, GError** error);
	void (*send_auth_code) (FreeSmartphoneGSMSIM* self, const char* pin, GError** error);
	void (*unlock) (FreeSmartphoneGSMSIM* self, const char* puk, const char* new_pin, GError** error);
	void (*change_auth_code) (FreeSmartphoneGSMSIM* self, const char* old_pin, const char* new_pin, GError** error);
	void (*set_auth_code_required) (FreeSmartphoneGSMSIM* self, gboolean check, const char* pin, GError** error);
	gboolean (*get_auth_code_required) (FreeSmartphoneGSMSIM* self, GError** error);
	gboolean (*get_sim_ready) (FreeSmartphoneGSMSIM* self, GError** error);
	GHashTable* (*get_sim_info) (FreeSmartphoneGSMSIM* self, GError** error);
	char* (*send_generic_sim_command) (FreeSmartphoneGSMSIM* self, const char* command, GError** error);
	char* (*send_restricted_sim_command) (FreeSmartphoneGSMSIM* self, gint command, gint fileid, gint p1, gint p2, gint p3, const char* data, GError** error);
	FreeSmartphoneGSMSIMHomezone* (*get_home_zones) (FreeSmartphoneGSMSIM* self, int* result_length1, GError** error);
	char* (*get_issuer) (FreeSmartphoneGSMSIM* self, GError** error);
	GHashTable* (*get_provider_list) (FreeSmartphoneGSMSIM* self, GError** error);
	char** (*list_phonebooks) (FreeSmartphoneGSMSIM* self, int* result_length1, GError** error);
	GHashTable* (*get_phonebook_info) (FreeSmartphoneGSMSIM* self, const char* category, GError** error);
	FreeSmartphoneGSMSIMEntry* (*retrieve_phonebook) (FreeSmartphoneGSMSIM* self, const char* category, int* result_length1, GError** error);
	void (*delete_entry) (FreeSmartphoneGSMSIM* self, const char* category, gint index, GError** error);
	void (*store_entry) (FreeSmartphoneGSMSIM* self, const char* category, gint index, const char* name, const char* number, GError** error);
	void (*retrieve_entry) (FreeSmartphoneGSMSIM* self, const char* category, gint index, char** name, char** number, GError** error);
	GHashTable* (*get_messagebook_info) (FreeSmartphoneGSMSIM* self, GError** error);
	FreeSmartphoneGSMSIMMessage* (*retrieve_messagebook) (FreeSmartphoneGSMSIM* self, const char* category, int* result_length1, GError** error);
	char* (*get_service_center_number) (FreeSmartphoneGSMSIM* self, GError** error);
	void (*set_service_center_number) (FreeSmartphoneGSMSIM* self, const char* number, GError** error);
	void (*delete_message) (FreeSmartphoneGSMSIM* self, gint index, GError** error);
	gint (*store_message) (FreeSmartphoneGSMSIM* self, const char* recipient_number, const char* contents, GHashTable* properties, GError** error);
	void (*send_stored_message) (FreeSmartphoneGSMSIM* self, gint index, gint* transaction_index, char** timestamp, GError** error);
	void (*retrieve_message) (FreeSmartphoneGSMSIM* self, gint index, char** status, char** sender_number, char** contents, GHashTable** properties, GError** error);
};

struct _FreeSmartphoneTimeAlarmIface {
	GTypeInterface parent_iface;
	void (*clear_alarm) (FreeSmartphoneTimeAlarm* self, const char* busname, GError** error);
	void (*set_alarm) (FreeSmartphoneTimeAlarm* self, const char* busname, gint timestamp, GError** error);
};

struct _FreeSmartphonePIMMessageQueryIface {
	GTypeInterface parent_iface;
	gint (*get_result_count) (FreeSmartphonePIMMessageQuery* self, GError** error);
	void (*rewind) (FreeSmartphonePIMMessageQuery* self, GError** error);
	void (*skip) (FreeSmartphonePIMMessageQuery* self, gint count, GError** error);
	char* (*get_message_path) (FreeSmartphonePIMMessageQuery* self, GError** error);
	GHashTable* (*get_result) (FreeSmartphonePIMMessageQuery* self, GError** error);
	GHashTable** (*get_multiple_results) (FreeSmartphonePIMMessageQuery* self, gint count, int* result_length1, GError** error);
	void (*dispose_) (FreeSmartphonePIMMessageQuery* self, GError** error);
};

struct _FreeSmartphonePIMMessageFolderIface {
	GTypeInterface parent_iface;
	gint (*get_message_count) (FreeSmartphonePIMMessageFolder* self, GError** error);
	char** (*get_message_paths) (FreeSmartphonePIMMessageFolder* self, gint first, gint count, int* result_length1, GError** error);
};

struct _FreeSmartphonePIMSourcesIface {
	GTypeInterface parent_iface;
	void (*init_all_entries) (FreeSmartphonePIMSources* self, GError** error);
	gint (*get_entry_count) (FreeSmartphonePIMSources* self, GError** error);
	char** (*get_domains) (FreeSmartphonePIMSources* self, int* result_length1, GError** error);
	char* (*get_default_backend) (FreeSmartphonePIMSources* self, const char* domain, GError** error);
};

struct _FreeSmartphonePIMContactIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_content) (FreeSmartphonePIMContact* self, GError** error);
	GHashTable* (*get_multiple_fields) (FreeSmartphonePIMContact* self, const char* field_list, GError** error);
	char** (*get_used_backends) (FreeSmartphonePIMContact* self, int* result_length1, GError** error);
	void (*update) (FreeSmartphonePIMContact* self, GHashTable* contact_data, GError** error);
	void (*delete) (FreeSmartphonePIMContact* self, GError** error);
};

struct _FreeSmartphonePIMContactsIface {
	GTypeInterface parent_iface;
	char* (*add) (FreeSmartphonePIMContacts* self, GHashTable* contact_data, GError** error);
	char* (*get_single_contact_single_field) (FreeSmartphonePIMContacts* self, GHashTable* query, const char* field, GError** error);
	char* (*query) (FreeSmartphonePIMContacts* self, GHashTable* query, GError** error);
};

struct _FreeSmartphonePIMContactQueryIface {
	GTypeInterface parent_iface;
	gint (*get_result_count) (FreeSmartphonePIMContactQuery* self, GError** error);
	void (*rewind) (FreeSmartphonePIMContactQuery* self, GError** error);
	void (*skip) (FreeSmartphonePIMContactQuery* self, gint count, GError** error);
	char* (*get_contact_path) (FreeSmartphonePIMContactQuery* self, GError** error);
	GHashTable* (*get_result) (FreeSmartphonePIMContactQuery* self, GError** error);
	GHashTable** (*get_multiple_results) (FreeSmartphonePIMContactQuery* self, gint count, int* result_length1, GError** error);
	void (*dispose_) (FreeSmartphonePIMContactQuery* self, GError** error);
};

struct _FreeSmartphonePIMMessagesIface {
	GTypeInterface parent_iface;
	char* (*add) (FreeSmartphonePIMMessages* self, GHashTable* message_data, GError** error);
	char* (*get_single_message_single_field) (FreeSmartphonePIMMessages* self, GHashTable* query, const char* field, GError** error);
	char* (*query) (FreeSmartphonePIMMessages* self, GHashTable* query, GError** error);
	char** (*get_folder_names) (FreeSmartphonePIMMessages* self, int* result_length1, GError** error);
	char* (*get_folder_path_from_name) (FreeSmartphonePIMMessages* self, const char* folder_name, GError** error);
};

struct _FreeSmartphonePIMSourceIface {
	GTypeInterface parent_iface;
	char* (*get_name) (FreeSmartphonePIMSource* self, GError** error);
	char* (*get_status) (FreeSmartphonePIMSource* self, GError** error);
	char** (*get_supported_p_i_m_domains) (FreeSmartphonePIMSource* self, int* result_length1, GError** error);
	void (*enable) (FreeSmartphonePIMSource* self, GError** error);
	void (*disable) (FreeSmartphonePIMSource* self, GError** error);
	gboolean (*get_enabled) (FreeSmartphonePIMSource* self, GError** error);
	char** (*get_properties) (FreeSmartphonePIMSource* self, int* result_length1, GError** error);
	void (*set_as_default) (FreeSmartphonePIMSource* self, const char* domain, GError** error);
};

struct _FreeSmartphonePIMMessageIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_content) (FreeSmartphonePIMMessage* self, GError** error);
	void (*get_multiple_fields) (FreeSmartphonePIMMessage* self, const char* field_list, GError** error);
	void (*move_to_folder) (FreeSmartphonePIMMessage* self, const char* folder_name, GError** error);
	void (*update) (FreeSmartphonePIMMessage* self, GHashTable* message_data, GError** error);
	void (*delete) (FreeSmartphonePIMMessage* self, GError** error);
};


GQuark free_smartphone_error_quark (void);
GType free_smartphone_phone_get_type (void);
char** free_smartphone_phone_init_protocols (FreeSmartphonePhone* self, int* result_length1, GError** error);
char* free_smartphone_phone_create_call (FreeSmartphonePhone* self, const char* number, const char* protocol, gboolean force, GError** error);
GType free_smartphone_usage_system_action_get_type (void);
GQuark free_smartphone_resource_error_quark (void);
GType free_smartphone_resource_get_type (void);
void free_smartphone_resource_enable (FreeSmartphoneResource* self, GError** error);
void free_smartphone_resource_disable (FreeSmartphoneResource* self, GError** error);
void free_smartphone_resource_suspend (FreeSmartphoneResource* self, GError** error);
void free_smartphone_resource_resume (FreeSmartphoneResource* self, GError** error);
GType free_smartphone_usage_resource_policy_get_type (void);
GType free_smartphone_phone_call_get_type (void);
char* free_smartphone_phone_call_get_peer (FreeSmartphonePhoneCall* self, GError** error);
char* free_smartphone_phone_call_initiate (FreeSmartphonePhoneCall* self, GError** error);
char* free_smartphone_phone_call_activate (FreeSmartphonePhoneCall* self, GError** error);
char* free_smartphone_phone_call_release (FreeSmartphonePhoneCall* self, GError** error);
char* free_smartphone_phone_call_get_status (FreeSmartphonePhoneCall* self, GError** error);
void free_smartphone_phone_call_remove (FreeSmartphonePhoneCall* self, GError** error);
GType free_smartphone_preferences_get_type (void);
char** free_smartphone_preferences_get_services (FreeSmartphonePreferences* self, int* result_length1, GError** error);
char* free_smartphone_preferences_get_service (FreeSmartphonePreferences* self, const char* name, GError** error);
char** free_smartphone_preferences_get_profiles (FreeSmartphonePreferences* self, int* result_length1, GError** error);
char* free_smartphone_preferences_get_profile (FreeSmartphonePreferences* self, GError** error);
void free_smartphone_preferences_set_profile (FreeSmartphonePreferences* self, const char* profile, GError** error);
GQuark free_smartphone_usage_error_quark (void);
GType free_smartphone_network_get_type (void);
void free_smartphone_network_start_connection_sharing_with_interface (FreeSmartphoneNetwork* self, const char* interface, GError** error);
GType free_smartphone_usage_get_type (void);
void free_smartphone_usage_register_resource (FreeSmartphoneUsage* self, const char* name, const char* path, GError** error);
void free_smartphone_usage_unregister_resource (FreeSmartphoneUsage* self, const char* name, GError** error);
char** free_smartphone_usage_list_resources (FreeSmartphoneUsage* self, int* result_length1, GError** error);
FreeSmartphoneUsageResourcePolicy free_smartphone_usage_get_resource_policy (FreeSmartphoneUsage* self, const char* name, GError** error);
void free_smartphone_usage_set_resource_policy (FreeSmartphoneUsage* self, const char* name, FreeSmartphoneUsageResourcePolicy policy, GError** error);
gboolean free_smartphone_usage_get_resource_state (FreeSmartphoneUsage* self, const char* name, GError** error);
char** free_smartphone_usage_get_resource_users (FreeSmartphoneUsage* self, const char* name, int* result_length1, GError** error);
void free_smartphone_usage_request_resource (FreeSmartphoneUsage* self, const char* name, GError** error);
void free_smartphone_usage_release_resource (FreeSmartphoneUsage* self, const char* name, GError** error);
void free_smartphone_usage_suspend (FreeSmartphoneUsage* self, GError** error);
void free_smartphone_usage_shutdown (FreeSmartphoneUsage* self, GError** error);
void free_smartphone_usage_reboot (FreeSmartphoneUsage* self, GError** error);
GType free_smartphone_preferences_service_get_type (void);
char** free_smartphone_preferences_service_get_keys (FreeSmartphonePreferencesService* self, int* result_length1, GError** error);
GValue free_smartphone_preferences_service_get_value (FreeSmartphonePreferencesService* self, const char* key, GError** error);
void free_smartphone_preferences_service_set_value (FreeSmartphonePreferencesService* self, const char* key, const GValue* value, GError** error);
gboolean free_smartphone_preferences_service_is_profilable (FreeSmartphonePreferencesService* self, const char* key, GError** error);
char* free_smartphone_preferences_service_get_type_ (FreeSmartphonePreferencesService* self, const char* key, GError** error);
GType free_smartphone_events_get_type (void);
void free_smartphone_events_add_rule (FreeSmartphoneEvents* self, const char* rule, GError** error);
void free_smartphone_events_remove_rule (FreeSmartphoneEvents* self, const char* name, GError** error);
void free_smartphone_events_trigger_test (FreeSmartphoneEvents* self, const char* name, gboolean value, GError** error);
GQuark free_smartphone_device_audio_error_quark (void);
GType free_smartphone_device_idle_state_get_type (void);
GType free_smartphone_device_power_status_get_type (void);
GType free_smartphone_device_input_get_type (void);
char* free_smartphone_device_input_get_id (FreeSmartphoneDeviceInput* self, GError** error);
char* free_smartphone_device_input_get_capabilities (FreeSmartphoneDeviceInput* self, GError** error);
GType free_smartphone_device_sound_state_get_type (void);
GType free_smartphone_device_led_get_type (void);
void free_smartphone_device_led_set_brightness (FreeSmartphoneDeviceLED* self, gint brightness, GError** error);
void free_smartphone_device_led_set_blinking (FreeSmartphoneDeviceLED* self, gint on_duration, gint off_duration, GError** error);
void free_smartphone_device_led_blink_seconds (FreeSmartphoneDeviceLED* self, gint seconds, gint on_duration, gint off_duration, GError** error);
void free_smartphone_device_led_set_networking (FreeSmartphoneDeviceLED* self, const char* interface, const char* mode, GError** error);
GType free_smartphone_device_power_supply_get_type (void);
GHashTable* free_smartphone_device_power_supply_get_info (FreeSmartphoneDevicePowerSupply* self, GError** error);
gint free_smartphone_device_power_supply_get_capacity (FreeSmartphoneDevicePowerSupply* self, GError** error);
FreeSmartphoneDevicePowerStatus free_smartphone_device_power_supply_get_power_status (FreeSmartphoneDevicePowerSupply* self, GError** error);
GType free_smartphone_device_info_get_type (void);
GHashTable* free_smartphone_device_info_get_cpu_info (FreeSmartphoneDeviceInfo* self, GError** error);
GType free_smartphone_device_power_control_get_type (void);
gboolean free_smartphone_device_power_control_get_power (FreeSmartphoneDevicePowerControl* self, GError** error);
void free_smartphone_device_power_control_set_power (FreeSmartphoneDevicePowerControl* self, gboolean on, GError** error);
GType free_smartphone_device_input_state_get_type (void);
GType free_smartphone_device_display_get_type (void);
GHashTable* free_smartphone_device_display_get_info (FreeSmartphoneDeviceDisplay* self, GError** error);
gint free_smartphone_device_display_get_brightness (FreeSmartphoneDeviceDisplay* self, GError** error);
void free_smartphone_device_display_set_brightness (FreeSmartphoneDeviceDisplay* self, gint brightness, GError** error);
gboolean free_smartphone_device_display_get_backlight_power (FreeSmartphoneDeviceDisplay* self, GError** error);
void free_smartphone_device_display_set_backlight_power (FreeSmartphoneDeviceDisplay* self, gboolean power, GError** error);
GType free_smartphone_device_realtime_clock_get_type (void);
gint free_smartphone_device_realtime_clock_get_current_time (FreeSmartphoneDeviceRealtimeClock* self, GError** error);
void free_smartphone_device_realtime_clock_set_current_time (FreeSmartphoneDeviceRealtimeClock* self, gint time, GError** error);
gint free_smartphone_device_realtime_clock_get_wakeup_time (FreeSmartphoneDeviceRealtimeClock* self, GError** error);
void free_smartphone_device_realtime_clock_set_wakeup_time (FreeSmartphoneDeviceRealtimeClock* self, gint time, GError** error);
GType free_smartphone_device_audio_get_type (void);
GHashTable* free_smartphone_device_audio_get_info (FreeSmartphoneDeviceAudio* self, GError** error);
char** free_smartphone_device_audio_get_supported_formats (FreeSmartphoneDeviceAudio* self, int* result_length1, GError** error);
char** free_smartphone_device_audio_get_available_scenarios (FreeSmartphoneDeviceAudio* self, int* result_length1, GError** error);
void free_smartphone_device_audio_play_sound (FreeSmartphoneDeviceAudio* self, const char* name, gint loop, gint length, GError** error);
void free_smartphone_device_audio_stop_sound (FreeSmartphoneDeviceAudio* self, const char* name, GError** error);
void free_smartphone_device_audio_stop_all_sounds (FreeSmartphoneDeviceAudio* self, GError** error);
char* free_smartphone_device_audio_get_scenario (FreeSmartphoneDeviceAudio* self, GError** error);
void free_smartphone_device_audio_set_scenario (FreeSmartphoneDeviceAudio* self, const char* scenario, GError** error);
void free_smartphone_device_audio_push_scenario (FreeSmartphoneDeviceAudio* self, const char* scenario, GError** error);
char* free_smartphone_device_audio_pull_scenario (FreeSmartphoneDeviceAudio* self, GError** error);
GType free_smartphone_device_idle_notifier_get_type (void);
FreeSmartphoneDeviceIdleState free_smartphone_device_idle_notifier_get_state (FreeSmartphoneDeviceIdleNotifier* self, GError** error);
GHashTable* free_smartphone_device_idle_notifier_get_timeouts (FreeSmartphoneDeviceIdleNotifier* self, GError** error);
void free_smartphone_device_idle_notifier_set_timeout (FreeSmartphoneDeviceIdleNotifier* self, FreeSmartphoneDeviceIdleState status, gint timeout, GError** error);
void free_smartphone_device_idle_notifier_set_state (FreeSmartphoneDeviceIdleNotifier* self, FreeSmartphoneDeviceIdleState status, GError** error);
GType free_smartphone_gsm_pdp_get_type (void);
char** free_smartphone_gsm_pdp_list_gprs_classes (FreeSmartphoneGSMPDP* self, int* result_length1, GError** error);
char* free_smartphone_gsm_pdp_get_current_gprs_class (FreeSmartphoneGSMPDP* self, GError** error);
void free_smartphone_gsm_pdp_set_current_gprs_class (FreeSmartphoneGSMPDP* self, const char* device_class, GError** error);
GHashTable* free_smartphone_gsm_pdp_get_network_status (FreeSmartphoneGSMPDP* self, GError** error);
gint free_smartphone_gsm_pdp_activate_context (FreeSmartphoneGSMPDP* self, const char* apn, const char* username, const char* password, GError** error);
void free_smartphone_gsm_pdp_deactivate_context (FreeSmartphoneGSMPDP* self, gint index, GError** error);
char* free_smartphone_gsm_pdp_get_context_status (FreeSmartphoneGSMPDP* self, gint index, GError** error);
GType free_smartphone_gsm_hz_get_type (void);
char** free_smartphone_gsm_hz_get_known_home_zones (FreeSmartphoneGSMHZ* self, int* result_length1, GError** error);
char* free_smartphone_gsm_hz_get_home_zone_status (FreeSmartphoneGSMHZ* self, GError** error);
GType free_smartphone_gsm_call_status_get_type (void);
GType free_smartphone_gsm_sim_auth_status_get_type (void);
GType free_smartphone_gsm_monitor_neighbour_cell_get_type (void);
FreeSmartphoneGSMMonitorNeighbourCell* free_smartphone_gsm_monitor_neighbour_cell_dup (const FreeSmartphoneGSMMonitorNeighbourCell* self);
void free_smartphone_gsm_monitor_neighbour_cell_free (FreeSmartphoneGSMMonitorNeighbourCell* self);
void free_smartphone_gsm_monitor_neighbour_cell_copy (const FreeSmartphoneGSMMonitorNeighbourCell* self, FreeSmartphoneGSMMonitorNeighbourCell* dest);
void free_smartphone_gsm_monitor_neighbour_cell_destroy (FreeSmartphoneGSMMonitorNeighbourCell* self);
GType free_smartphone_gsm_monitor_get_type (void);
GHashTable* free_smartphone_gsm_monitor_get_serving_cell_information (FreeSmartphoneGSMMonitor* self, GError** error);
FreeSmartphoneGSMMonitorNeighbourCell* free_smartphone_gsm_monitor_get_neighbour_cell_information (FreeSmartphoneGSMMonitor* self, int* result_length1, GError** error);
GQuark free_smartphone_gsm_call_error_quark (void);
GType free_smartphone_gsm_mux_get_type (void);
void free_smartphone_gsm_mux_open_session (FreeSmartphoneGSMMUX* self, gboolean advanced, gint framesize, const char* portname, gint portspeed, GError** error);
void free_smartphone_gsm_mux_close_session (FreeSmartphoneGSMMUX* self, GError** error);
void free_smartphone_gsm_mux_alloc_channel (FreeSmartphoneGSMMUX* self, const char* origin, gint channel, char** path, gint* allocated_channel, GError** error);
void free_smartphone_gsm_mux_release_channel (FreeSmartphoneGSMMUX* self, const char* origin, GError** error);
void free_smartphone_gsm_mux_set_status (FreeSmartphoneGSMMUX* self, gint channel, const char* status, GError** error);
GType free_smartphone_gsm_device_get_type (void);
GHashTable* free_smartphone_gsm_device_get_info (FreeSmartphoneGSMDevice* self, GError** error);
gboolean free_smartphone_gsm_device_get_antenna_power (FreeSmartphoneGSMDevice* self, GError** error);
void free_smartphone_gsm_device_set_antenna_power (FreeSmartphoneGSMDevice* self, gboolean antenna_power, GError** error);
GHashTable* free_smartphone_gsm_device_get_features (FreeSmartphoneGSMDevice* self, GError** error);
gint free_smartphone_gsm_device_get_speaker_volume (FreeSmartphoneGSMDevice* self, GError** error);
void free_smartphone_gsm_device_set_speaker_volume (FreeSmartphoneGSMDevice* self, gint volume, GError** error);
gboolean free_smartphone_gsm_device_get_microphone_muted (FreeSmartphoneGSMDevice* self, GError** error);
void free_smartphone_gsm_device_set_microphone_muted (FreeSmartphoneGSMDevice* self, gboolean muted, GError** error);
void free_smartphone_gsm_device_get_power_status (FreeSmartphoneGSMDevice* self, char** status, gint* level, GError** error);
gboolean free_smartphone_gsm_device_get_sim_buffers_sms (FreeSmartphoneGSMDevice* self, GError** error);
void free_smartphone_gsm_device_set_sim_buffers_sms (FreeSmartphoneGSMDevice* self, gboolean sim_buffers_sms, GError** error);
GType free_smartphone_gsm_sms_get_type (void);
void free_smartphone_gsm_sms_send_message (FreeSmartphoneGSMSMS* self, const char* recipient_number, const char* contents, GHashTable* properties, gint* transaction_index, char** timestamp, GError** error);
void free_smartphone_gsm_sms_ack_message (FreeSmartphoneGSMSMS* self, const char* contents, GHashTable* properties, GError** error);
void free_smartphone_gsm_sms_nack_message (FreeSmartphoneGSMSMS* self, const char* contents, GHashTable* properties, GError** error);
GType free_smartphone_gsm_call_detail_get_type (void);
FreeSmartphoneGSMCallDetail* free_smartphone_gsm_call_detail_dup (const FreeSmartphoneGSMCallDetail* self);
void free_smartphone_gsm_call_detail_free (FreeSmartphoneGSMCallDetail* self);
void free_smartphone_gsm_call_detail_copy (const FreeSmartphoneGSMCallDetail* self, FreeSmartphoneGSMCallDetail* dest);
void free_smartphone_gsm_call_detail_destroy (FreeSmartphoneGSMCallDetail* self);
GType free_smartphone_gsm_call_get_type (void);
void free_smartphone_gsm_call_emergency (FreeSmartphoneGSMCall* self, const char* number, GError** error);
void free_smartphone_gsm_call_activate (FreeSmartphoneGSMCall* self, gint id, GError** error);
void free_smartphone_gsm_call_activate_conference (FreeSmartphoneGSMCall* self, gint id, GError** error);
void free_smartphone_gsm_call_release (FreeSmartphoneGSMCall* self, gint id, GError** error);
void free_smartphone_gsm_call_hold_active (FreeSmartphoneGSMCall* self, GError** error);
void free_smartphone_gsm_call_join (FreeSmartphoneGSMCall* self, GError** error);
void free_smartphone_gsm_call_transfer (FreeSmartphoneGSMCall* self, const char* number, GError** error);
void free_smartphone_gsm_call_release_held (FreeSmartphoneGSMCall* self, GError** error);
void free_smartphone_gsm_call_release_all (FreeSmartphoneGSMCall* self, GError** error);
gint free_smartphone_gsm_call_initiate (FreeSmartphoneGSMCall* self, const char* number, const char* type, GError** error);
FreeSmartphoneGSMCallDetail* free_smartphone_gsm_call_list_calls (FreeSmartphoneGSMCall* self, int* result_length1, GError** error);
void free_smartphone_gsm_call_send_dtmf (FreeSmartphoneGSMCall* self, const char* tones, GError** error);
GType free_smartphone_gsm_network_provider_get_type (void);
FreeSmartphoneGSMNetworkProvider* free_smartphone_gsm_network_provider_dup (const FreeSmartphoneGSMNetworkProvider* self);
void free_smartphone_gsm_network_provider_free (FreeSmartphoneGSMNetworkProvider* self);
void free_smartphone_gsm_network_provider_copy (const FreeSmartphoneGSMNetworkProvider* self, FreeSmartphoneGSMNetworkProvider* dest);
void free_smartphone_gsm_network_provider_destroy (FreeSmartphoneGSMNetworkProvider* self);
GType free_smartphone_gsm_network_get_type (void);
void free_smartphone_gsm_network_register_ (FreeSmartphoneGSMNetwork* self, GError** error);
void free_smartphone_gsm_network_unregister (FreeSmartphoneGSMNetwork* self, GError** error);
GHashTable* free_smartphone_gsm_network_get_status (FreeSmartphoneGSMNetwork* self, GError** error);
gint free_smartphone_gsm_network_get_signal_strength (FreeSmartphoneGSMNetwork* self, GError** error);
FreeSmartphoneGSMNetworkProvider* free_smartphone_gsm_network_list_providers (FreeSmartphoneGSMNetwork* self, int* result_length1, GError** error);
void free_smartphone_gsm_network_register_with_provider (FreeSmartphoneGSMNetwork* self, const char* operator_code, GError** error);
void free_smartphone_gsm_network_get_network_country_code (FreeSmartphoneGSMNetwork* self, char** dial_code, char** country_name, GError** error);
GHashTable* free_smartphone_gsm_network_get_call_forwarding (FreeSmartphoneGSMNetwork* self, const char* reason, GError** error);
void free_smartphone_gsm_network_enable_call_forwarding (FreeSmartphoneGSMNetwork* self, const char* reason, const char* class_, const char* number, gint timeout, GError** error);
void free_smartphone_gsm_network_disable_call_forwarding (FreeSmartphoneGSMNetwork* self, const char* reason, const char* class_, GError** error);
void free_smartphone_gsm_network_set_calling_identification (FreeSmartphoneGSMNetwork* self, const char* visible, GError** error);
char* free_smartphone_gsm_network_get_calling_identification (FreeSmartphoneGSMNetwork* self, GError** error);
void free_smartphone_gsm_network_send_ussd_request (FreeSmartphoneGSMNetwork* self, const char* request, GError** error);
GType free_smartphone_gsm_cb_get_type (void);
char* free_smartphone_gsm_cb_get_cell_broadcast_subscriptions (FreeSmartphoneGSMCB* self, GError** error);
void free_smartphone_gsm_cb_set_cell_broadcast_subscriptions (FreeSmartphoneGSMCB* self, const char* channels, GError** error);
GType free_smartphone_gsm_sim_homezone_get_type (void);
FreeSmartphoneGSMSIMHomezone* free_smartphone_gsm_sim_homezone_dup (const FreeSmartphoneGSMSIMHomezone* self);
void free_smartphone_gsm_sim_homezone_free (FreeSmartphoneGSMSIMHomezone* self);
void free_smartphone_gsm_sim_homezone_copy (const FreeSmartphoneGSMSIMHomezone* self, FreeSmartphoneGSMSIMHomezone* dest);
void free_smartphone_gsm_sim_homezone_destroy (FreeSmartphoneGSMSIMHomezone* self);
GType free_smartphone_gsm_sim_entry_get_type (void);
FreeSmartphoneGSMSIMEntry* free_smartphone_gsm_sim_entry_dup (const FreeSmartphoneGSMSIMEntry* self);
void free_smartphone_gsm_sim_entry_free (FreeSmartphoneGSMSIMEntry* self);
void free_smartphone_gsm_sim_entry_copy (const FreeSmartphoneGSMSIMEntry* self, FreeSmartphoneGSMSIMEntry* dest);
void free_smartphone_gsm_sim_entry_destroy (FreeSmartphoneGSMSIMEntry* self);
GType free_smartphone_gsm_sim_message_get_type (void);
FreeSmartphoneGSMSIMMessage* free_smartphone_gsm_sim_message_dup (const FreeSmartphoneGSMSIMMessage* self);
void free_smartphone_gsm_sim_message_free (FreeSmartphoneGSMSIMMessage* self);
void free_smartphone_gsm_sim_message_copy (const FreeSmartphoneGSMSIMMessage* self, FreeSmartphoneGSMSIMMessage* dest);
void free_smartphone_gsm_sim_message_destroy (FreeSmartphoneGSMSIMMessage* self);
GType free_smartphone_gsm_sim_get_type (void);
FreeSmartphoneGSMSIMAuthStatus free_smartphone_gsm_sim_get_auth_status (FreeSmartphoneGSMSIM* self, GError** error);
void free_smartphone_gsm_sim_send_auth_code (FreeSmartphoneGSMSIM* self, const char* pin, GError** error);
void free_smartphone_gsm_sim_unlock (FreeSmartphoneGSMSIM* self, const char* puk, const char* new_pin, GError** error);
void free_smartphone_gsm_sim_change_auth_code (FreeSmartphoneGSMSIM* self, const char* old_pin, const char* new_pin, GError** error);
void free_smartphone_gsm_sim_set_auth_code_required (FreeSmartphoneGSMSIM* self, gboolean check, const char* pin, GError** error);
gboolean free_smartphone_gsm_sim_get_auth_code_required (FreeSmartphoneGSMSIM* self, GError** error);
gboolean free_smartphone_gsm_sim_get_sim_ready (FreeSmartphoneGSMSIM* self, GError** error);
GHashTable* free_smartphone_gsm_sim_get_sim_info (FreeSmartphoneGSMSIM* self, GError** error);
char* free_smartphone_gsm_sim_send_generic_sim_command (FreeSmartphoneGSMSIM* self, const char* command, GError** error);
char* free_smartphone_gsm_sim_send_restricted_sim_command (FreeSmartphoneGSMSIM* self, gint command, gint fileid, gint p1, gint p2, gint p3, const char* data, GError** error);
FreeSmartphoneGSMSIMHomezone* free_smartphone_gsm_sim_get_home_zones (FreeSmartphoneGSMSIM* self, int* result_length1, GError** error);
char* free_smartphone_gsm_sim_get_issuer (FreeSmartphoneGSMSIM* self, GError** error);
GHashTable* free_smartphone_gsm_sim_get_provider_list (FreeSmartphoneGSMSIM* self, GError** error);
char** free_smartphone_gsm_sim_list_phonebooks (FreeSmartphoneGSMSIM* self, int* result_length1, GError** error);
GHashTable* free_smartphone_gsm_sim_get_phonebook_info (FreeSmartphoneGSMSIM* self, const char* category, GError** error);
FreeSmartphoneGSMSIMEntry* free_smartphone_gsm_sim_retrieve_phonebook (FreeSmartphoneGSMSIM* self, const char* category, int* result_length1, GError** error);
void free_smartphone_gsm_sim_delete_entry (FreeSmartphoneGSMSIM* self, const char* category, gint index, GError** error);
void free_smartphone_gsm_sim_store_entry (FreeSmartphoneGSMSIM* self, const char* category, gint index, const char* name, const char* number, GError** error);
void free_smartphone_gsm_sim_retrieve_entry (FreeSmartphoneGSMSIM* self, const char* category, gint index, char** name, char** number, GError** error);
GHashTable* free_smartphone_gsm_sim_get_messagebook_info (FreeSmartphoneGSMSIM* self, GError** error);
FreeSmartphoneGSMSIMMessage* free_smartphone_gsm_sim_retrieve_messagebook (FreeSmartphoneGSMSIM* self, const char* category, int* result_length1, GError** error);
char* free_smartphone_gsm_sim_get_service_center_number (FreeSmartphoneGSMSIM* self, GError** error);
void free_smartphone_gsm_sim_set_service_center_number (FreeSmartphoneGSMSIM* self, const char* number, GError** error);
void free_smartphone_gsm_sim_delete_message (FreeSmartphoneGSMSIM* self, gint index, GError** error);
gint free_smartphone_gsm_sim_store_message (FreeSmartphoneGSMSIM* self, const char* recipient_number, const char* contents, GHashTable* properties, GError** error);
void free_smartphone_gsm_sim_send_stored_message (FreeSmartphoneGSMSIM* self, gint index, gint* transaction_index, char** timestamp, GError** error);
void free_smartphone_gsm_sim_retrieve_message (FreeSmartphoneGSMSIM* self, gint index, char** status, char** sender_number, char** contents, GHashTable** properties, GError** error);
GType free_smartphone_time_alarm_get_type (void);
void free_smartphone_time_alarm_clear_alarm (FreeSmartphoneTimeAlarm* self, const char* busname, GError** error);
void free_smartphone_time_alarm_set_alarm (FreeSmartphoneTimeAlarm* self, const char* busname, gint timestamp, GError** error);
GType free_smartphone_pim_message_query_get_type (void);
gint free_smartphone_pim_message_query_get_result_count (FreeSmartphonePIMMessageQuery* self, GError** error);
void free_smartphone_pim_message_query_rewind (FreeSmartphonePIMMessageQuery* self, GError** error);
void free_smartphone_pim_message_query_skip (FreeSmartphonePIMMessageQuery* self, gint count, GError** error);
char* free_smartphone_pim_message_query_get_message_path (FreeSmartphonePIMMessageQuery* self, GError** error);
GHashTable* free_smartphone_pim_message_query_get_result (FreeSmartphonePIMMessageQuery* self, GError** error);
GHashTable** free_smartphone_pim_message_query_get_multiple_results (FreeSmartphonePIMMessageQuery* self, gint count, int* result_length1, GError** error);
void free_smartphone_pim_message_query_dispose_ (FreeSmartphonePIMMessageQuery* self, GError** error);
GType free_smartphone_pim_message_folder_get_type (void);
gint free_smartphone_pim_message_folder_get_message_count (FreeSmartphonePIMMessageFolder* self, GError** error);
char** free_smartphone_pim_message_folder_get_message_paths (FreeSmartphonePIMMessageFolder* self, gint first, gint count, int* result_length1, GError** error);
GType free_smartphone_pim_sources_get_type (void);
void free_smartphone_pim_sources_init_all_entries (FreeSmartphonePIMSources* self, GError** error);
gint free_smartphone_pim_sources_get_entry_count (FreeSmartphonePIMSources* self, GError** error);
char** free_smartphone_pim_sources_get_domains (FreeSmartphonePIMSources* self, int* result_length1, GError** error);
char* free_smartphone_pim_sources_get_default_backend (FreeSmartphonePIMSources* self, const char* domain, GError** error);
GType free_smartphone_pim_contact_get_type (void);
GHashTable* free_smartphone_pim_contact_get_content (FreeSmartphonePIMContact* self, GError** error);
GHashTable* free_smartphone_pim_contact_get_multiple_fields (FreeSmartphonePIMContact* self, const char* field_list, GError** error);
char** free_smartphone_pim_contact_get_used_backends (FreeSmartphonePIMContact* self, int* result_length1, GError** error);
void free_smartphone_pim_contact_update (FreeSmartphonePIMContact* self, GHashTable* contact_data, GError** error);
void free_smartphone_pim_contact_delete (FreeSmartphonePIMContact* self, GError** error);
GType free_smartphone_pim_contacts_get_type (void);
char* free_smartphone_pim_contacts_add (FreeSmartphonePIMContacts* self, GHashTable* contact_data, GError** error);
char* free_smartphone_pim_contacts_get_single_contact_single_field (FreeSmartphonePIMContacts* self, GHashTable* query, const char* field, GError** error);
char* free_smartphone_pim_contacts_query (FreeSmartphonePIMContacts* self, GHashTable* query, GError** error);
GType free_smartphone_pim_contact_query_get_type (void);
gint free_smartphone_pim_contact_query_get_result_count (FreeSmartphonePIMContactQuery* self, GError** error);
void free_smartphone_pim_contact_query_rewind (FreeSmartphonePIMContactQuery* self, GError** error);
void free_smartphone_pim_contact_query_skip (FreeSmartphonePIMContactQuery* self, gint count, GError** error);
char* free_smartphone_pim_contact_query_get_contact_path (FreeSmartphonePIMContactQuery* self, GError** error);
GHashTable* free_smartphone_pim_contact_query_get_result (FreeSmartphonePIMContactQuery* self, GError** error);
GHashTable** free_smartphone_pim_contact_query_get_multiple_results (FreeSmartphonePIMContactQuery* self, gint count, int* result_length1, GError** error);
void free_smartphone_pim_contact_query_dispose_ (FreeSmartphonePIMContactQuery* self, GError** error);
GType free_smartphone_pim_messages_get_type (void);
char* free_smartphone_pim_messages_add (FreeSmartphonePIMMessages* self, GHashTable* message_data, GError** error);
char* free_smartphone_pim_messages_get_single_message_single_field (FreeSmartphonePIMMessages* self, GHashTable* query, const char* field, GError** error);
char* free_smartphone_pim_messages_query (FreeSmartphonePIMMessages* self, GHashTable* query, GError** error);
char** free_smartphone_pim_messages_get_folder_names (FreeSmartphonePIMMessages* self, int* result_length1, GError** error);
char* free_smartphone_pim_messages_get_folder_path_from_name (FreeSmartphonePIMMessages* self, const char* folder_name, GError** error);
GType free_smartphone_pim_source_get_type (void);
char* free_smartphone_pim_source_get_name (FreeSmartphonePIMSource* self, GError** error);
char* free_smartphone_pim_source_get_status (FreeSmartphonePIMSource* self, GError** error);
char** free_smartphone_pim_source_get_supported_p_i_m_domains (FreeSmartphonePIMSource* self, int* result_length1, GError** error);
void free_smartphone_pim_source_enable (FreeSmartphonePIMSource* self, GError** error);
void free_smartphone_pim_source_disable (FreeSmartphonePIMSource* self, GError** error);
gboolean free_smartphone_pim_source_get_enabled (FreeSmartphonePIMSource* self, GError** error);
char** free_smartphone_pim_source_get_properties (FreeSmartphonePIMSource* self, int* result_length1, GError** error);
void free_smartphone_pim_source_set_as_default (FreeSmartphonePIMSource* self, const char* domain, GError** error);
GType free_smartphone_pim_message_get_type (void);
GHashTable* free_smartphone_pim_message_get_content (FreeSmartphonePIMMessage* self, GError** error);
void free_smartphone_pim_message_get_multiple_fields (FreeSmartphonePIMMessage* self, const char* field_list, GError** error);
void free_smartphone_pim_message_move_to_folder (FreeSmartphonePIMMessage* self, const char* folder_name, GError** error);
void free_smartphone_pim_message_update (FreeSmartphonePIMMessage* self, GHashTable* message_data, GError** error);
void free_smartphone_pim_message_delete (FreeSmartphonePIMMessage* self, GError** error);


G_END_DECLS

#endif
